#include "blinkTask.hpp"
#include "bluetooth.hpp"
#include "../osHandles.h"
#include "drivers/i2c.h"
#include "utils/rprintf.h"     // rprintf
#include "drivers/uart1.h"     // uart0GetChar()
#include "drivers/uart0.h"     // uart0GetChar()

void Config_Blink()
{
	const char portExpanderI2CAddr = 0x40;
	// Port0 is for LEDs

	const char ledPortConfigNum = 6;

	initialize_I2C0(100 * 1000);  //100kHz frequency    LEDS and SWithces
	const char configureForOutput = 0x00;   // LEDS

	i2cWriteDeviceRegister(portExpanderI2CAddr, ledPortConfigNum, configureForOutput);
}

void blinkTask(void* p)
{
	OSHANDLES *osHandles = (OSHANDLES*) p;

	Config_Blink();

	const char portExpanderI2CAddr = 0x40;
	const char ledPortRegNum = 2;

	const char forward = 'F';
	const char forward_left = 'L';
	const char forward_right = 'R';
	const char backwards = 'B';
	const char backwards_left = 'S';
	const char backwards_right = 'T';
	const char donut_right = 'D';
	const char donut_left = 'C';
	const char fast = 'X';
	const char slow = 'W';

	char SwitchData = 0;

	for (;;)
	{
		char name2;
		int timer = 0;
		int BlinkingTime = 500;
		if (xQueueReceive(osHandles->queue.blink, &name2, portMAX_DELAY))
		{
			SwitchData = name2;
			rprintf("switch data in blink task is %c", SwitchData);

			switch (SwitchData)
			{

			case forward:

			i2cWriteDeviceRegister(portExpanderI2CAddr, ledPortRegNum, 0x55);
			vTaskDelay(100);

			i2cWriteDeviceRegister(portExpanderI2CAddr, ledPortRegNum, 0xAA);
			vTaskDelay(100);

			while (timer < BlinkingTime)
			{

				vTaskDelay(1);
				timer++;
			}
			timer = 0;
			break;

			case forward_left:

			i2cWriteDeviceRegister(portExpanderI2CAddr, ledPortRegNum, 0x55);
			vTaskDelay(100);

			i2cWriteDeviceRegister(portExpanderI2CAddr, ledPortRegNum, 0xAA);
			vTaskDelay(100);

			while (timer < BlinkingTime)
			{
				vTaskDelay(1);
				timer++;
			}
			timer = 0;
			break;

			case forward_right:

			i2cWriteDeviceRegister(portExpanderI2CAddr, ledPortRegNum, 0x55);
			vTaskDelay(100);

			i2cWriteDeviceRegister(portExpanderI2CAddr, ledPortRegNum, 0xAA);
			vTaskDelay(100);
			while (timer < BlinkingTime)
			{
				vTaskDelay(1);
				timer++;
			}
			timer = 0;
			break;

			case backwards:

			i2cWriteDeviceRegister(portExpanderI2CAddr, ledPortRegNum, 0xAA);
			vTaskDelay(100);
			i2cWriteDeviceRegister(portExpanderI2CAddr, ledPortRegNum, 0x55);
			vTaskDelay(100);
			while (timer < BlinkingTime)
			{
				vTaskDelay(1);
				timer++;
			}
			timer = 0;
			break;

			case backwards_left:

			i2cWriteDeviceRegister(portExpanderI2CAddr, ledPortRegNum, 0xAA);
			vTaskDelay(100);
			i2cWriteDeviceRegister(portExpanderI2CAddr, ledPortRegNum, 0x55);
			vTaskDelay(100);
			while (timer < BlinkingTime)
			{
				vTaskDelay(1);
				timer++;
			}
			timer = 0;
			break;

			case backwards_right:

			i2cWriteDeviceRegister(portExpanderI2CAddr, ledPortRegNum, 0xAA);
			vTaskDelay(100);
			i2cWriteDeviceRegister(portExpanderI2CAddr, ledPortRegNum, 0x55);
			vTaskDelay(100);
			while (timer < BlinkingTime)
			{
				vTaskDelay(1);
				timer++;
			}
			timer = 0;
			break;

			case donut_right:

			i2cWriteDeviceRegister(portExpanderI2CAddr, ledPortRegNum, 0x55);
			vTaskDelay(100);
			i2cWriteDeviceRegister(portExpanderI2CAddr, ledPortRegNum, 0xAA);
			vTaskDelay(100);
			while (timer < BlinkingTime)
			{
				vTaskDelay(1);
				timer++;
			}
			timer = 0;
			break;

			case donut_left:

			i2cWriteDeviceRegister(portExpanderI2CAddr, ledPortRegNum, 0x55);
			vTaskDelay(100);
			i2cWriteDeviceRegister(portExpanderI2CAddr, ledPortRegNum, 0xAA);
			vTaskDelay(100);
			while (timer < BlinkingTime)
			{
				vTaskDelay(1);
				timer++;
			}
			timer = 0;
			break;

			case fast:

			i2cWriteDeviceRegister(portExpanderI2CAddr, ledPortRegNum, 0xFF);
			vTaskDelay(100);
			break;

			case slow:

			i2cWriteDeviceRegister(portExpanderI2CAddr, ledPortRegNum, 0xAA);
			vTaskDelay(100);
			i2cWriteDeviceRegister(portExpanderI2CAddr, ledPortRegNum, 0x55);
			vTaskDelay(100);
			break;

			default:
			break;
			}
		}
		else
			rprintf("Nothing Received");
	}
}
