#include "bluetooth.hpp"
#include "../osHandles.h"
#include "drivers/uart1.h"     // uart0GetChar()
#include "drivers/uart0.h"     // uart0GetChar()
#include "utils/rprintf.h"     // rprintf

void getUart1Line();
void bluetooth(void* p)
{
	OSHANDLES *osHandles = (OSHANDLES*) p;
	uart1Init(9600, 128);
	char data;
	char blinkData;
	for (;;)
	{
		vTaskDelay(100);
		if (uart1GetChar(&data, portMAX_DELAY))
		{
			if (data == 'F')
			{
				blinkData = 'F';
				rprintf("drive Forward!");
				xQueueSend(osHandles->queue.command, &data,portMAX_DELAY);
				xQueueSend(osHandles->queue.blink, &blinkData,portMAX_DELAY);
			}
			else if (data == 'B')
			{
				blinkData = 'B';
				rprintf("drive backward!");
				xQueueSend(osHandles->queue.command, &data,portMAX_DELAY);
				xQueueSend(osHandles->queue.blink, &blinkData,portMAX_DELAY);
			}
			else if (data == 'L')
			{
				blinkData = 'L';
				rprintf("drive Forward left!");
				xQueueSend(osHandles->queue.command, &data,portMAX_DELAY);
				xQueueSend(osHandles->queue.blink, &blinkData,portMAX_DELAY);
			}
			else if (data == 'R')
			{
				blinkData = 'R';
				rprintf("drive Forward right!");
				xQueueSend(osHandles->queue.command, &data,portMAX_DELAY);
				xQueueSend(osHandles->queue.blink, &blinkData,portMAX_DELAY);
			}
			else if (data == 'S')
			{
				blinkData = 'S';
				rprintf("drive backward left!");
				xQueueSend(osHandles->queue.command, &data,portMAX_DELAY);
				xQueueSend(osHandles->queue.blink, &blinkData,portMAX_DELAY);
			}
			else if (data == 'T')
			{
				blinkData = 'T';
				rprintf("drive backward right!");
				xQueueSend(osHandles->queue.command, &data,portMAX_DELAY);
				xQueueSend(osHandles->queue.blink, &blinkData,portMAX_DELAY);
			}
			else if (data == 'D')
			{
				blinkData = 'D';
					rprintf("drive Donut!");
					xQueueSend(osHandles->queue.command, &data,portMAX_DELAY);
					xQueueSend(osHandles->queue.blink, &blinkData,portMAX_DELAY);
			}
			else if (data == 'C')
			{
				blinkData = 'C';
				rprintf("drive Donut!");
				xQueueSend(osHandles->queue.command, &data,portMAX_DELAY);
				xQueueSend(osHandles->queue.blink, &blinkData,portMAX_DELAY);
			}
			else if (data == 'W')
			{
				blinkData = 'W';
				rprintf("drive slow!");
				xQueueSend(osHandles->queue.command, &data,portMAX_DELAY);
				xQueueSend(osHandles->queue.blink, &blinkData,portMAX_DELAY);
			}
			else if (data == 'X')
			{
				blinkData = 'X';
				rprintf("drive fast!");
				xQueueSend(osHandles->queue.command, &data,portMAX_DELAY);
				xQueueSend(osHandles->queue.blink, &blinkData,portMAX_DELAY);
			}
			else
			{
				rprintf("command not recognized");
				//do nothing
			}
		}
	}
}

